#!/usr/bin/env python3
import random
from multiprocessing import Process
import subprocess
from time import sleep

FILE_SIZE = 3052871
NUM_PROC = 31
VOLUME_PATH = "/tmp/pythontest"

def get_random_sleep_time():
	return random.randint(0,59)

def check_if_rebuild():
	mdstat_result = subprocess.run("cat /proc/mdstat | grep %", shell=True, universal_newlines=True, stdout=subprocess.PIPE)
	if "%" in mdstat_result.stdout:
		return True
	return False

def perform_checksum_test(doSleep):
	if doSleep == True:
		sleep(get_random_sleep_time())

	test_result = subprocess.run("./data_m " + str(FILE_SIZE) + " " + VOLUME_PATH, shell=True, universal_newlines=True, stdout=subprocess.PIPE)

	if test_result.returncode > 0:
		print(test_result.stdout)

# ------------ END OF FUNCTIONS ------------- #

# Before starting the test, you should get familiar and execute prepare_rebuild_env.sh script!
# Make sure you are doing this in safe environment!

processes = []
print("Test started!")
while True:
	array_rebuild = check_if_rebuild()

	if len(processes) < NUM_PROC and array_rebuild == True:
		proc = Process(target = perform_checksum_test, args = (True,))
		processes.append(proc)
		proc.start()
		print("start")
	
	for index,proc in enumerate(processes):
		if proc.is_alive() == False:
			processes.pop(index)

	if array_rebuild == False:
		for proc in processes:
			proc.join()
		break
print ("Rebuild ended, testing done!")
